import math
from collections import namedtuple

Point = namedtuple("Point", ['x', 'y'])


def length(point1, point2):
    return math.sqrt((point1.x - point2.x) ** 2 + (point1.y - point2.y) ** 2)


def load_problem(args):
    file_location = args[1].strip()
    input_data_file = open(file_location, 'r')
    input_data = ''.join(input_data_file.readlines())
    input_data_file.close()
    return input_data


def preprocess(input_data):
    # parse the input
    lines = input_data.split('\n')

    nodeCount = int(lines[0])

    points = []
    for i in range(1, nodeCount + 1):
        line = lines[i]
        parts = line.split()
        points.append(Point(float(parts[0]), float(parts[1])))

    # distance matrix
    c = [0] * nodeCount
    for i in range(nodeCount):
        c[i] = [0] * nodeCount

    for i in range(nodeCount):
        for j in range(nodeCount):
            c[i][j] = length(points[i], points[j])

    return points, nodeCount, c


def output_sol(nodeCount, x, points):
    solution = []
    i = 0
    start = True
    while i != 0 or start:
        solution.append(i)
        start = False
        for k in range(nodeCount):
            if x[i,k].getAttr("x") > 0:
                i = k
                break

    # calculate the utils.length of the tour
    obj = length(points[solution[-1]], points[solution[0]])
    for index in range(0, nodeCount - 1):
        obj += length(points[solution[index]], points[solution[index + 1]])

    # prepare the solution in the specified output format
    output_data = str(obj) + ' ' + str(0) + '\n'
    output_data += ' '.join(map(str, solution))

    return output_data
